#include <stdio.h>

#define NIMI "John Smith" /* etu konstantu zameni svoim imenem */
#define SISF "GRAVI.SIS" /* imya vhodnogo faila */
#define VALF "GRAVI.VAL" /* imya vyhodnogo faila */
#define MAXN 6 /* razmer igrovogo polya */
#define MAXK 4 /* skolko fishek v ryad nuzhno postavit dlya vyigrysha */

FILE *f; /* vhodnoi-vyhodnoi fail */
char kaik; /* chei hod */
char seis[MAXN][MAXN]; /* igrovoe pole */

int main()
{
    int i, j;

    /* schityvaem vhodnye dannye */
    f = fopen(SISF, "rt");
    fscanf(f, "%c%*c", &kaik);
    if (kaik != '0')
        for (i = 0; i < MAXN; ++i) {
            for (j = 0; j < MAXN; ++j)
                fscanf(f, "%c", &seis[i][j]);
            fscanf(f, "%*c");
        }
    fclose(f);

    /* esli na pervoi stroke vhodnogo faila 0, vyvodim imya avtora */
    if (kaik == '0') {
        f = fopen(VALF, "wt");
        fprintf(f, "%s\n", NIMI);
        fclose(f);
        return 0;
    }

    /*----- Nachalo algoritma  -----*/

    /* Suda napishi svoi algoritm */
    /* V kachestve primera priveden algoritm, kotoryi delayet pervyi popavshiisa
		razreshennyi hod */

    /* nahodim stolbec, kuda mozhno opustit fishku */
    for (j = 0; j < MAXN; ++j)
        if (seis[0][j] == '0') {
            /* v stolbce nahodim mesto, kuda upadet fishka */
            for (i = MAXN - 1; i >= 0; --i)
                if (seis[i][j] == '0') {
                    seis[i][j] = kaik;
                    break; /* i vyhodim */
            }
            break; /* nashli, vyhodim */
        }

    /*----- Konec algoritma -----*/

    /* vyvodim resultat */
    f = fopen(VALF, "wt");
    for (i = 0; i < MAXN; ++i) {
        for (j = 0; j < MAXN; ++j)
            fprintf(f, "%c", seis[i][j]);
        fprintf(f, "\n");
    }
    fclose(f);
    return 0;
}
