{ 020415-2.PAS                                                              }
{ 2002-04-15 programmeerimisolmpiaadi 2. lesande lahendus                 }
{    USSIMNG                                                               }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

{ TPC annab vaikimisi liiga vikese magasini }
{$M 60000, 0, 0}

const
   sisf = 'USS.SIS';
   valf = 'USS.VAL';
   maxn = 50;                                  { maksimaalne joonise suurus }
   maxt = maxn * maxn div 4;                      { maksimaalne tippude arv }

type
   info = record
      mark : char;
      tipp : integer;
   end;

var
   a : array [0..maxn+1, 0..maxn+1] of info;                       { joonis }
   tarv : integer;                                     { graafi tippude arv }
   tast : array [1..maxt] of integer;            { tippude lokaalsed astmed }

{ loeb sisendfailist joonise }
procedure loe_joonis;
var f : text; n, i, j : integer; s : string;
begin
   { teeme joonise puhtaks }
   for i := 0 to maxn + 1 do
      for j := 0 to maxn + 1 do begin
         a[i, j].mark := ' ';
         a[i, j].tipp := 0;
      end;

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do begin
      readln(f, s);
      for j := 1 to length(s) do
         a[i, j].mark := s[j];
   end;
   close(f);
end;

{ leiab joonisele vastava graafi tipud }
procedure leia_tipud;
   procedure margi_tipp(i, j, k : integer);
   begin
      if (i < 0) or (i > maxn + 1) or (j < 0) or (j > maxn + 1) then
         exit;
      if (a[i, j].mark <> ' ') or (a[i, j].tipp <> 0) then
         exit;
      a[i, j].tipp := k;
      margi_tipp(i - 1, j, k);
      margi_tipp(i + 1, j, k);
      margi_tipp(i, j - 1, k);
      margi_tipp(i, j + 1, k);
   end;
var i, j : integer;
begin
   tarv := 0;
   for i := 0 to maxn + 1 do
      for j := 0 to maxn + 1 do
         if (a[i, j].mark = ' ') and (a[i, j].tipp = 0) then begin
            tarv := tarv + 1;
            margi_tipp(i, j, tarv);
         end;
end;

{ leiab joonisele vastava graafi servad }
procedure leia_servad;
var i, j, t : integer;
begin
   for i := 1 to tarv do
      tast[i] := 0;
   for i := 1 to maxn do
      for j := 1 to maxn do begin
        if (a[i - 1, j].mark = '+') and (a[i, j].mark = '|') then begin
           { leidsime vertikaalse serva }
           t := a[i, j - 1].tipp;
           if t = 0 then begin writeln('Viga1 ', i, ' ', j); halt(1); end;
           tast[t] := tast[t] + 1;
           t := a[i, j + 1].tipp;
           if t = 0 then begin writeln('Viga2 ', i, ' ', j); halt(1); end;
           tast[t] := tast[t] + 1;
        end;
        if (a[i, j - 1].mark = '+') and (a[i, j].mark = '-') then begin
           { leidsime horisontaalse serva }
           t := a[i - 1, j].tipp;
           if t = 0 then begin writeln('Viga3 ', i, ' ', j); halt(1); end;
           tast[t] := tast[t] + 1;
           t := a[i + 1, j].tipp;
           if t = 0 then begin writeln('Viga4 ', i, ' ', j); halt(1); end;
           tast[t] := tast[t] + 1;
        end;
      end;
end;

{ kontrollib graafi eulerilisust ja vljastab vastuse }
procedure tee_vastus;
var f : text; i, k : integer;
begin
   { loendame paaritu astmega tipud }
   k := 0;
   for i := 1 to tarv do
      k := k + tast[i] mod 2;
   { teeme vastuse }
   assign(f, valf); rewrite(f);
   if k > 2 then
      writeln(f, 'EI')
   else
      writeln(f, 'JAH');
   close(f);
end;

begin
   loe_joonis;
   leia_tipud;
   leia_servad;
   tee_vastus;
end.
