{ kontroll.pas                                                              }
{ 2002-04-15 programmeerimisolmpiaadi 1. lesande tester                   }
{    SIDUS GRAAF                                                            }
{ Ahto Truu                                                                 }

{$I+}

const
   maxn = 100;                            { maksimaalne tippude arv graafis }

var
   f : text;                                           { sisend/vljundfail }
   n, m : integer;                                 { tippude ja servade arv }
   a : array [1..maxn, 1..maxn] of boolean;               { naabrusmaatriks }

   i, j, k : integer;
   b : boolean;
   s : string;
   x, y : integer;

begin
   if paramcount <> 2 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;

   { algvrtustame maatriksi }
   for i := 1 to maxn do
      for j := 1 to maxn do
         a[i, j] := false;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, n, m);
   for i := 1 to m do begin
      readln(f, j, k);
      a[j, k] := true;
   end;
   close(f);

   { leiame kik tipupaarid, mille vahel on tee }
   repeat
      b := false;
      for i := 1 to n do
         for j := 1 to n do
            if a[i, j] then
               for k := 1 to n do
                  if a[j, k] then
                     if not a[i, k] then begin
                        b := true;
                        a[i, k] := true;
                     end;
   until not b;

   { otsime tipupaari, mille vahel pole teed }
   b := true;
   for i := 1 to n do
      for j := 1 to n do
         if i <> j then
            if not a[i, j] and not a[j, i] then begin
               b := false;
            end;

   { loeme vljundfaili }
   assign(f, paramstr(2)); reset(f);
   readln(f, s);
   if not seekeof(f) then begin
      readln(f, x, y)
   end else begin
      x := -1; y := -1;
   end;
   close(f);

   { kontrollime vastuse }
   if b then begin
      if s = 'JAH' then begin
         writeln('Vastus OK');
      end else begin
         writeln('Vale vastus: peaks olema JAH, on ', s);
      end;
   end else begin
      if s = 'EI' then begin
         writeln('Vastus OK');
      end else begin
         writeln('Vale vastus: peaks olema EI, on ', s);
      end;
      if (x < 1) or (x > maxn) or (y < 1) or (y > maxn) or (x = y) then begin
         writeln('Lubamatu tipupaar: ', x, ' ', y);
      end else if a[x, y] or a[y, x] then begin
         writeln('Tippude ', x, ' ja ', y, ' vahel ON tee');
      end else begin
         writeln('Tipud OK');
      end;
   end;
end.
