#include <stdio.h>

#define NIMI "John Smith" /* see konstant asenda oma nimega */
#define SISF "GRAVI.SIS" /* sisendfaili nimi */
#define VALF "GRAVI.VAL" /* vljundfaili nimi */
#define MAXN 6 /* mnguvlja suurus */
#define MAXK 4 /* viduks vajaliku rea pikkus */

FILE *f; /* sisend-vljundfail */
char kaik; /* kelle kik on */
char seis[MAXN][MAXN];

int main()
{
    int i, j;

    /* loeme sisendandmed */
    f = fopen(SISF, "rt");
    fscanf(f, "%c%*c", &kaik);
    if (kaik != '0')
        for (i = 0; i < MAXN; ++i) {
            for (j = 0; j < MAXN; ++j)
                fscanf(f, "%c", &seis[i][j]);
            fscanf(f, "%*c");
        }
    fclose(f);

    /* kui on tutvustamisevoor, vljastame autori nime */
    if (kaik == '0') {
        f = fopen(VALF, "wt");
        fprintf(f, "%s\n", NIMI);
        fclose(f);
        return 0;
    }

    /*----- kigu valimise algoritmi algus -----*/

    /* siia kirjuta oma algoritm */
    /* see nide siin teeb esimese ettejuhtuva lubatud kigu */

    /* otsime veergu, milles on veel ruumi */
    for (j = 0; j < MAXN; ++j)
        if (seis[0][j] == '0') {
            /* leiame selles veerus alumise vaba koha */
            for (i = MAXN - 1; i >= 0; --i)
                if (seis[i][j] == '0') {
                    seis[i][j] = kaik;
                    break; /* katkestame veerus otsimise */
            }
            break; /* katkestame reas otsimise */
        }

    /*----- kigu valimise algoritmi lpp -----*/

    /* vljastame tulemuse */
    f = fopen(VALF, "wt");
    for (i = 0; i < MAXN; ++i) {
        for (j = 0; j < MAXN; ++j)
            fprintf(f, "%c", seis[i][j]);
        fprintf(f, "\n");
    }
    fclose(f);
    return 0;
}
