#include <fstream>
using namespace std;

#define NIMI "John Smith" /* see konstant asenda oma nimega */
#define SISF "GRAVI.SIS" /* sisendfaili nimi */
#define VALF "GRAVI.VAL" /* vljundfaili nimi */
#define MAXN 6 /* mnguvlja suurus */
#define MAXK 4 /* viduks vajaliku rea pikkus */

fstream f; /* sisend-vljundfail */
char kaik; /* kelle kik on */
char seis[MAXN][MAXN];

int main()
{
    /* loeme sisendandmed */
    f.open(SISF, ios::in);
    f >> kaik;
    if (kaik != '0')
        for (int i = 0; i < MAXN; ++i) {
            for (int j = 0; j < MAXN; ++j)
                f >> seis[i][j];
        }
    f.close();

    /* kui on tutvustamisevoor, vljastame autori nime */
    if (kaik == '0') {
        f.open(VALF, ios::out);
        f << NIMI << endl;
        f.close();
        return 0;
    }

    /*----- kigu valimise algoritmi algus -----*/

    /* siia kirjuta oma algoritm */
    /* see nide siin teeb esimese ettejuhtuva lubatud kigu */

    /* otsime veergu, milles on veel ruumi */
    for (int j = 0; j < MAXN; ++j)
        if (seis[0][j] == '0') {
            /* leiame selles veerus alumise vaba koha */
            for (int i = MAXN - 1; i >= 0; --i)
                if (seis[i][j] == '0') {
                    seis[i][j] = kaik;
                    break; /* katkestame veerus otsimise */
            }
            break; /* katkestame reas otsimise */
        }

    /*----- kigu valimise algoritmi lpp -----*/

    /* vljastame tulemuse */
    f.open(VALF, ios::out);
    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j)
            f << seis[i][j];
        f << endl;
    }
    f.close();
    return 0;
}
