#include <fstream>
using namespace std;

#define NIMI "John Smith" /* etu konstantu zameni svoim imenem */
#define SISF "GRAVI.SIS" /* imya vhodnogo faila */
#define VALF "GRAVI.VAL" /* imya vyhodnogo faila */
#define MAXN 6 /* razmer igrovogo polya */
#define MAXK 4 /* skolko fishek v ryad nuzhno postavit dlya vyigrysha */

fstream f; /* vhodnoi-vyhodnoi fail */
char kaik; /* chei hod */
char seis[MAXN][MAXN]; /* igrovoe pole */

int main()
{
    /* schityvaem vhodnye dannye */
    f.open(SISF, ios::in);
    f >> kaik;
    if (kaik != '0')
        for (int i = 0; i < MAXN; ++i) {
            for (int j = 0; j < MAXN; ++j)
                f >> seis[i][j];
        }
    f.close();

    /* esli na pervoi stroke vhodnogo faila 0, vyvodim imya avtora */
    if (kaik == '0') {
        f.open(VALF, ios::out);
        f << NIMI << endl;
        f.close();
        return 0;
    }

    /*----- Nachalo algoritma  -----*/

    /* Suda napishi svoi algoritm */
    /* V kachestve primera priveden algoritm, kotoryi delayet pervyi popavshiisa
		razreshennyi hod */

    /* nahodim stolbec, kuda mozhno opustit fishku */
    for (int j = 0; j < MAXN; ++j)
        if (seis[0][j] == '0') {
            /* v stolbce nahodim mesto, kuda upadet fishka */
            for (int i = MAXN - 1; i >= 0; --i)
                if (seis[i][j] == '0') {
                    seis[i][j] = kaik;
                    break; /* i vyhodim */
            }
            break; /* nashli, vyhodim */
        }

    /*----- Konec algoritma -----*/

    /* vyvodim resultat */
    f.open(VALF, ios::out);
    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j)
            f << seis[i][j];
        f << endl;
    }
    f.close();
    return 0;
}
