{ 020415-3.PAS                                                              }
{ 2002-04-15 programmeerimisolmpiaadi 3. lesande lahendus                 }
{    HOKI                                                                   }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

const
   sisf = 'HOKI.SIS';
   valf = 'HOKI.VAL';

var
   f : text;                                           { sisend/vljundfail }
   x, y : real;                                           { vljaku mtmed }
   xl, yl : real;                                           { litri asukoht }
   vx, vy : real;                                   { litri kiirus (vektor) }
   xm, ym : real;                                         { mngija asukoht }
   v : real;                                     { mngija kiirus (skalaar) }

   t0 : real;                                                 { jooksev aeg }
   tp, tx, ty : real;                 { aeg jrgmise prkeni vljaku rega }
   a, b, c, d : real;                    { kohtumisaja vrrandi parameetrid }
   tok : boolean;                            { kas ajavrrandil oli lahend? }
   tk, t1, t2 : real;                                { ajavrrandi lahendid }

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, x, y);
   readln(f, xl, yl);
   readln(f, vx, vy);
   readln(f, xm, ym);
   readln(f, v);
   close(f);

   { simuleerime litri liikumist kuni kohtumiseni }
   t0 := 0;                                 { alustame aja lugemist nullist }
   while true do begin
      { arvutame aja jrgmise prkeni }
      tx := -1;
      if vx > 0 then tx := (x - xl) / vx;
      if vx < 0 then tx := -xl / vx;
      ty := -1;
      if vy > 0 then ty := (y - yl) / vy;
      if vy < 0 then ty := -yl / vy;
      tp := -1;
      if (tp = -1) or (tx < tp) then tp := tx;
      if (tp = -1) or (ty < tp) then tp := ty;

      { koostame ja lahendame kohtumisaja vrrandi }
      a := sqr(vx) + sqr(vy) - sqr(v);
      b := -2 * (vx * (xm - xl) + vy * (ym - yl) + t0 * sqr(v));
      c := sqr(xm - xl) + sqr(ym - yl) - sqr(t0 * v);
      if abs(a) > 0 then begin
         { ruutvrrand }
         d := sqr(b) - 4 * a * c;
         if d < 0 then begin
            { diskriminant negatiivne, lahendit pole }
            tok := false
         end else begin
            { lahendid on }
            tok := true;
            t1 := (-b - sqrt(d)) / (2 * a);
            t2 := (-b + sqrt(d)) / (2 * a);
         end;
      end else if abs(b) > 0 then begin
         { lineaarvrrand }
         tok := true;
         t1 := -c / b; t2 := -c / b;
      end else if abs(c) > 0 then begin
         { vastuolu }
         tok := false;
      end else begin
         { samasus 0 = 0 }
         tok := true;
         t1 := 0; t2 := 0;
      end;

      { leiame kohtumise aja }
      if tok then begin
         { kohtumine peab toimuma enne jrgmist prget }
         tk := -1;
         if (t1 >= 0) and (t1 <= tp) then
            if (tk < 0) or (t1 < tk) then
               tk := t1;
         if (t2 >= 0) and (t2 <= tp) then
            if (tk < 0) or (t2 < tk) then
               tk := t2;
         if tk < 0 then
            tok := false;
      end;

      { kui leidsime kohtumise, vljastame tulemuse ja lpp }
      if tok then begin
         assign(f, valf); rewrite(f);
         writeln(f, t0 + tk);
         close(f);
         exit;
      end;

      { modelleerime litri liikumise prkeni ja prke }
      xl := xl + vx * tp;
      yl := yl + vy * tp;
      if tp = tx then
         vx := -vx;
      if tp = ty then
         vy := -vy;
      t0 := t0 + tp;
   end;
end.
